=== modified file 'server/Makefile.am'
--- server/Makefile.am	2008-07-18 07:38:40 +0000
+++ server/Makefile.am	2008-07-18 09:08:53 +0000
@@ -82,7 +82,7 @@
 			item_row.cc \
 			field.cc field/blob.cc field/null.cc field/datetime.cc \
 			field/timetype.cc field/timestamp.cc field/date.cc field/year.cc \
-			field/decimal.cc field/string.cc field/varstring.cc\
+			field/decimal.cc field/double.cc field/string.cc field/varstring.cc\
 			strfunc.cc key.cc sql_class.cc sql_list.cc \
 			protocol.cc sql_state.c \
 			lock.cc \

=== modified file 'server/field.cc'
--- server/field.cc	2008-07-18 07:38:40 +0000
+++ server/field.cc	2008-07-18 09:08:53 +0000
@@ -44,10 +44,6 @@
 
 const char field_separator=',';
 
-#define DOUBLE_TO_STRING_CONVERSION_BUFFER_SIZE FLOATING_POINT_BUFFER
-#define LONGLONG_TO_STRING_CONVERSION_BUFFER_SIZE 128
-#define DECIMAL_TO_STRING_CONVERSION_BUFFER_SIZE 128
-
 /*
   Rules for merging different types of fields in UNION
 
@@ -2434,283 +2430,6 @@
 }
 
 /****************************************************************************
-  double precision floating point numbers
-****************************************************************************/
-
-int Field_double::store(const char *from,uint len,CHARSET_INFO *cs)
-{
-  int error;
-  char *end;
-  double nr= my_strntod(cs,(char*) from, len, &end, &error);
-  if (error || (!len || (((uint) (end-from) != len) && table->in_use->count_cuted_fields)))
-  {
-    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
-                (error ? ER_WARN_DATA_OUT_OF_RANGE : WARN_DATA_TRUNCATED), 1);
-    error= error ? 1 : 2;
-  }
-  Field_double::store(nr);
-  return error;
-}
-
-
-int Field_double::store(double nr)
-{
-  int error= truncate(&nr, DBL_MAX);
-
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    float8store(ptr,nr);
-  }
-  else
-#endif
-    doublestore(ptr,nr);
-  return error;
-}
-
-
-int Field_double::store(int64_t nr, bool unsigned_val)
-{
-  return Field_double::store(unsigned_val ? uint64_t2double((uint64_t) nr) :
-                             (double) nr);
-}
-
-/*
-  If a field has fixed length, truncate the double argument pointed to by 'nr'
-  appropriately.
-  Also ensure that the argument is within [-max_value; max_value] range.
-*/
-
-int Field_real::truncate(double *nr, double max_value)
-{
-  int error= 1;
-  double res= *nr;
-  
-  if (isnan(res))
-  {
-    res= 0;
-    set_null();
-    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-    goto end;
-  }
-  else if (unsigned_flag && res < 0)
-  {
-    res= 0;
-    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-    goto end;
-  }
-
-  if (!not_fixed)
-  {
-    uint order= field_length - dec;
-    uint step= array_elements(log_10) - 1;
-    max_value= 1.0;
-    for (; order > step; order-= step)
-      max_value*= log_10[step];
-    max_value*= log_10[order];
-    max_value-= 1.0 / log_10[dec];
-
-    /* Check for infinity so we don't get NaN in calculations */
-    if (!my_isinf(res))
-    {
-      double tmp= rint((res - floor(res)) * log_10[dec]) / log_10[dec];
-      res= floor(res) + tmp;
-    }
-  }
-  
-  if (res < -max_value)
-  {
-   res= -max_value;
-   set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-  }
-  else if (res > max_value)
-  {
-    res= max_value;
-    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-  }
-  else
-    error= 0;
-
-end:
-  *nr= res;
-  return error;
-}
-
-
-int Field_real::store_decimal(const my_decimal *dm)
-{
-  double dbl;
-  my_decimal2double(E_DEC_FATAL_ERROR, dm, &dbl);
-  return store(dbl);
-}
-
-double Field_double::val_real(void)
-{
-  double j;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    float8get(j,ptr);
-  }
-  else
-#endif
-    doubleget(j,ptr);
-  return j;
-}
-
-int64_t Field_double::val_int(void)
-{
-  double j;
-  int64_t res;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    float8get(j,ptr);
-  }
-  else
-#endif
-    doubleget(j,ptr);
-  /* Check whether we fit into int64_t range */
-  if (j <= (double) INT64_MIN)
-  {
-    res= (int64_t) INT64_MIN;
-    goto warn;
-  }
-  if (j >= (double) (uint64_t) INT64_MAX)
-  {
-    res= (int64_t) INT64_MAX;
-    goto warn;
-  }
-  return (int64_t) rint(j);
-
-warn:
-  {
-    char buf[DOUBLE_TO_STRING_CONVERSION_BUFFER_SIZE];
-    String tmp(buf, sizeof(buf), &my_charset_latin1), *str;
-    str= val_str(&tmp, 0);
-    push_warning_printf(current_thd, MYSQL_ERROR::WARN_LEVEL_WARN,
-                        ER_TRUNCATED_WRONG_VALUE,
-                        ER(ER_TRUNCATED_WRONG_VALUE), "INTEGER",
-                        str->c_ptr());
-  }
-  return res;
-}
-
-
-my_decimal *Field_real::val_decimal(my_decimal *decimal_value)
-{
-  double2my_decimal(E_DEC_FATAL_ERROR, val_real(), decimal_value);
-  return decimal_value;
-}
-
-
-String *Field_double::val_str(String *val_buffer,
-			      String *val_ptr __attribute__((unused)))
-{
-  double nr;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    float8get(nr,ptr);
-  }
-  else
-#endif
-    doubleget(nr,ptr);
-
-  uint to_length=max(field_length, DOUBLE_TO_STRING_CONVERSION_BUFFER_SIZE);
-  val_buffer->alloc(to_length);
-  char *to=(char*) val_buffer->ptr();
-  size_t len;
-
-  if (dec >= NOT_FIXED_DEC)
-    len= my_gcvt(nr, MY_GCVT_ARG_DOUBLE, to_length - 1, to, NULL);
-  else
-    len= my_fcvt(nr, dec, to, NULL);
-
-  val_buffer->length((uint) len);
-  if (zerofill)
-    prepend_zeros(val_buffer);
-  return val_buffer;
-}
-
-bool Field_double::send_binary(Protocol *protocol)
-{
-  return protocol->store((double) Field_double::val_real(), dec, (String*) 0);
-}
-
-
-int Field_double::cmp(const uchar *a_ptr, const uchar *b_ptr)
-{
-  double a,b;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    float8get(a,a_ptr);
-    float8get(b,b_ptr);
-  }
-  else
-#endif
-  {
-    doubleget(a, a_ptr);
-    doubleget(b, b_ptr);
-  }
-  return (a < b) ? -1 : (a > b) ? 1 : 0;
-}
-
-
-#define DBL_EXP_DIG (sizeof(double)*8-DBL_MANT_DIG)
-
-/* The following should work for IEEE */
-
-void Field_double::sort_string(uchar *to,uint length __attribute__((unused)))
-{
-  double nr;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    float8get(nr,ptr);
-  }
-  else
-#endif
-    doubleget(nr,ptr);
-  change_double_for_sort(nr, to);
-}
-
-
-/**
-   Save the field metadata for double fields.
-
-   Saves the pack length in the first byte of the field metadata array
-   at index of *metadata_ptr.
-
-   @param   metadata_ptr   First byte of field metadata
-
-   @returns number of bytes written to metadata_ptr
-*/
-int Field_double::do_save_field_metadata(uchar *metadata_ptr)
-{
-  *metadata_ptr= pack_length();
-  return 1;
-}
-
-
-void Field_double::sql_type(String &res) const
-{
-  CHARSET_INFO *cs=res.charset();
-  if (dec == NOT_FIXED_DEC)
-  {
-    res.set_ascii(STRING_WITH_LEN("double"));
-  }
-  else
-  {
-    res.length(cs->cset->snprintf(cs,(char*) res.ptr(),res.alloced_length(),
-			    "double(%d,%d)",(int) field_length,dec));
-  }
-  add_zerofill_and_unsigned(res);
-}
-
-
-/****************************************************************************
 ** string type
 ** A string may be varchar or binary
 ****************************************************************************/

=== modified file 'server/field.h'
--- server/field.h	2008-07-18 07:38:40 +0000
+++ server/field.h	2008-07-18 09:08:53 +0000
@@ -24,6 +24,8 @@
 #endif
 
 #define DATETIME_DEC                     6
+#define DOUBLE_TO_STRING_CONVERSION_BUFFER_SIZE FLOATING_POINT_BUFFER
+
 const uint32 max_field_size= (uint32) 4294967295U;
 
 class Send_field;
@@ -918,45 +920,6 @@
   }
 };
 
-class Field_double :public Field_real {
-public:
-  Field_double(uchar *ptr_arg, uint32 len_arg, uchar *null_ptr_arg,
-	       uchar null_bit_arg,
-	       enum utype unireg_check_arg, const char *field_name_arg,
-	       uint8 dec_arg,bool zero_arg,bool unsigned_arg)
-    :Field_real(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
-                unireg_check_arg, field_name_arg,
-                dec_arg, zero_arg, unsigned_arg)
-    {}
-  Field_double(uint32 len_arg, bool maybe_null_arg, const char *field_name_arg,
-	       uint8 dec_arg)
-    :Field_real((uchar*) 0, len_arg, maybe_null_arg ? (uchar*) "" : 0, (uint) 0,
-                NONE, field_name_arg, dec_arg, 0, 0)
-    {}
-  Field_double(uint32 len_arg, bool maybe_null_arg, const char *field_name_arg,
-	       uint8 dec_arg, my_bool not_fixed_arg)
-    :Field_real((uchar*) 0, len_arg, maybe_null_arg ? (uchar*) "" : 0, (uint) 0,
-                NONE, field_name_arg, dec_arg, 0, 0)
-    {not_fixed= not_fixed_arg; }
-  enum_field_types type() const { return MYSQL_TYPE_DOUBLE;}
-  enum ha_base_keytype key_type() const { return HA_KEYTYPE_DOUBLE; }
-  int  store(const char *to,uint length,CHARSET_INFO *charset);
-  int  store(double nr);
-  int  store(int64_t nr, bool unsigned_val);
-  int reset(void) { bzero(ptr,sizeof(double)); return 0; }
-  double val_real(void);
-  int64_t val_int(void);
-  String *val_str(String*,String *);
-  bool send_binary(Protocol *protocol);
-  int cmp(const uchar *,const uchar *);
-  void sort_string(uchar *buff,uint length);
-  uint32 pack_length() const { return sizeof(double); }
-  uint row_pack_length() { return pack_length(); }
-  void sql_type(String &str) const;
-private:
-  int do_save_field_metadata(uchar *first_byte);
-};
-
 
 class Field_enum :public Field_str {
 protected:
@@ -1168,6 +1131,7 @@
 #include "field/year.h"
 #include "field/date.h"
 #include "field/decimal.h"
+#include "field/double.h"
 #include "field/timetype.h"
 #include "field/timestamp.h"
 #include "field/datetime.h"

=== modified file 'server/field/string.cc'
--- server/field/string.cc	2008-07-18 07:38:40 +0000
+++ server/field/string.cc	2008-07-18 09:08:53 +0000
@@ -24,7 +24,6 @@
 
 #include "string.h"
 
-#define DOUBLE_TO_STRING_CONVERSION_BUFFER_SIZE FLOATING_POINT_BUFFER
 #define LONGLONG_TO_STRING_CONVERSION_BUFFER_SIZE 128
 #define DECIMAL_TO_STRING_CONVERSION_BUFFER_SIZE 128
 

